//Create global variables
let invaderCount = 10;
let invaders = [];
let gameState = 1;
let health = 100;
let invaderFrequency = 100;
let invaderX = 0;
let invaderY = 150;
let invadersKilled = 0;
let levelTwoCheck = false;
let invaderTakeDmg = false;
let clicked = false;
let invadersLeft = 10;
let damageSound;

//create global variables used in path and invader classes
let line1StartX = 0;
let line1StartY = 150;
let line1EndX;
let line1EndY = 150;

let line2StartX = line1EndX;
let line2StartY = line1EndY;
let line2EndX = line1EndX;
let line2EndY;

let line3StartX = line2EndX;
let line3StartY = line2EndY;
let line3EndX;
let line3EndY = line2EndY;

let line4StartX = line3EndX;
let line4StartY = line3EndY;
let line4EndX = line3EndX;
let line4EndY;

let line5StartX = line4EndX;
let line5StartY = line4EndY;
let line5EndX;
let line5EndY = line4EndY;

let line6StartX = line5EndX;
let line6StartY = line5EndY;
let line6EndX = line5EndX;
let line6EndY = 450;

let line7StartX = line6EndX;
let line7StartY = line6EndY;
let line7EndX = 640;
let line7EndY = 450;

function preload() {
  soundFormats("wav");
  damageSound = loadSound("click.wav");
}

function setup() {
  //create canvas
  createCanvas(640, 480);
  background(255);

  //generate pathway coordinates randomly
  line1EndX = round(random(40, 600));
  line2EndY = round(random(line1EndY + 20, 300));
  line3EndX = round(random(40, 600));
  line5EndX = round(random(40, 600));

  line2StartX = line1EndX;
  line2EndX = line1EndX;

  line3StartX = line2EndX;
  line3StartY = line2EndY;
  line3EndY = line2EndY;

  line4EndY = round(random(line3EndY + 20, 400));

  line4StartX = line3EndX;
  line4StartY = line3EndY;
  line4EndX = line3EndX;

  line5StartX = line4EndX;
  line5StartY = line4EndY;
  line5EndY = line4EndY;

  line6StartX = line5EndX;
  line6StartY = line5EndY;
  line6EndX = line5EndX;

  line7StartX = line6EndX;
  line7StartY = line6EndY;

  path = new Path(line1StartX, line1StartY, line1EndX, line1EndY, line2StartX, line2StartY, line2EndX, line2EndY, line3StartX, line3StartY, line3EndX, line3EndY,
    line4StartX, line4StartY, line4EndX, line4EndY, line5StartX, line5StartY, line5EndX, line5EndY, line6StartX, line6StartY, line6EndX, line6EndY,
    line7StartX, line7StartY, line7EndX, line7EndY);
}

function draw() {
  //switch to game over state condition
  if (health < 1) {
    gameState = 0;
  }

  //switch to level 1 state condition
  if (gameState == 1 && (invadersKilled == 10 && invaderCount == 0) || gameState == 1 && (health < 100 && invadersLeft == 0)) {
    gameState = 2;
    levelTwoCheck = true;
    invadersLeft = 15;
  }

  //switch to level 2 state condition
  if (gameState == 2 && (invadersKilled == 15 && invaderCount == 0) || gameState == 2 && (health < 100 && invadersLeft == 0)) {
    gameState = 3;
  }
  switch (gameState) {
    case 0:
      gameOver();
      break;

    case 1:
      levelOne();
      break;

    case 2:
      levelTwo();
      break;

    case 3:
      youWin();
  }
}

function levelOne() {
  frameRate(60);
  background(255);
  //draw UI
  textSize(24);
  fill(0);
  textAlign(LEFT, CENTER);
  text("Health: " + health, 20, 20);
  text("Level: " + gameState, 550, 20);
  textSize(15);
  text("Click on invaders to defeat them", (width / 2) - 10, 20);

  //draw pathway
  path.generate();

  //count down invader spawn timer
  invaderFrequency--;

  //conditions to spawn invader
  if (invaderFrequency === 0) {
    if (invaderCount > 0) {
      invaders.push(new Invader(line1StartX, line1StartY, line1EndX, line1EndY, line2StartX, line2StartY, line2EndX, line2EndY, line3StartX, line3StartY, line3EndX, line3EndY,
        line4StartX, line4StartY, line4EndX, line4EndY, line5StartX, line5StartY, line5EndX, line5EndY, line6StartX, line6StartY, line6EndX, line6EndY,
        line7StartX, line7StartY, line7EndX, line7EndY, invaderX, invaderY));
      invaderFrequency += 100;
      invaderCount -= 1;
    }
  }

  //draw multiple invaders in array
  for (let i = 0; i < invaders.length; i++) {
    invaders[i].move();
  }
}

function levelTwo() {
  frameRate(60);
  background(255);
  //draw UI
  textSize(24);
  fill(0);
  textAlign(LEFT, CENTER);
  text("Health: " + health, 20, 20);
  text("Level: " + gameState, 550, 20);
  textSize(15);
  text("Difficulty increased...", (width / 2) - 10, 20);

  //draw pathway
  path.generate();

  //changes values for level 2 for increased difficulty, resets invaders
  if(levelTwoCheck == true) {
    invaderCount = 15;
    invaders = [];
    invadersKilled = 0;
    levelTwoCheck = false;
    invaderFrequency = 50;
    invaderX = 0;
    invaderY = 150;
  }

  //count down invader spawn timer
  invaderFrequency--;
  if (invaderFrequency === 0) {

    //higher frequency for level 2
    if (invaderCount > 0) {
      invaders.push(new Invader(line1StartX, line1StartY, line1EndX, line1EndY, line2StartX, line2StartY, line2EndX, line2EndY, line3StartX, line3StartY, line3EndX, line3EndY,
        line4StartX, line4StartY, line4EndX, line4EndY, line5StartX, line5StartY, line5EndX, line5EndY, line6StartX, line6StartY, line6EndX, line6EndY,
        line7StartX, line7StartY, line7EndX, line7EndY, invaderX, invaderY));
      invaderFrequency += 50;
      invaderCount -= 1;
    }
  }

  for (let i = 0; i < invaders.length; i++) {
    invaders[i].move();
    // invaders[i].mouseClicked();
  }
}

function gameOver() {
  textSize(100);
  textAlign(CENTER, CENTER);
  text("GAME OVER", width / 2, height / 2);
}

function youWin() {
  fill(0, 255, 0);
  textSize(100);
  textAlign(CENTER, CENTER);
  text("You Win!", width / 2, height / 2);
  textSize(20);
  text("You had enough health to survive both waves!", width / 2, (height / 2) + 50);

}

//executes when mouse clicked
function mouseClicked() {
  clicked = true;
}

// function keyPressed() {
//   mySound.stop();
// }